diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index 2c22886c..b837e7a1 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -73,233 +164,377 @@ class SquadService extends Actor {
     }
   }
 
-  def GetSquad(id : PlanetSideGUID) : Option[Squad] = {
-    squadFeatures.get(id) match {
-      case Some(features) => Some(features.Squad)
-      case None => None
-    }
+  /**
+    * If a squad exists for an identifier, return that squad.
+    * @param id the squad unique identifier number
+    * @return the discovered squad, or `None`
+    */
+  def GetSquad(id : PlanetSideGUID) : Option[Squad] = squadFeatures.get(id) match {
+    case Some(features) => Some(features.Squad)
+    case None => None
   }
 
-  def GetParticipatingSquad(player : Player) : Option[Squad] = {
-    GetParticipatingSquad(player.CharId)
+  /**
+    * If this player is a member of any squad, discover that squad.
+    * @param player the potential member
+    * @return the discovered squad, or `None`
+    */
+  def GetParticipatingSquad(player : Player) : Option[Squad] = GetParticipatingSquad(player.CharId)
+
+  /**
+    * If the player associated with this unique character identifier number is a member of any squad, discover that squad.
+    * @param charId the potential member identifier
+    * @return the discovered squad, or `None`
+    */
+  def GetParticipatingSquad(charId : Long) : Option[Squad] = memberToSquad.get(charId) match {
+    case opt @ Some(_) =>
+      opt
+    case None =>
+      None
   }
 
-  def GetParticipatingSquad(charId : Long) : Option[Squad] = {
-    memberToSquad.get(charId) match {
-      case opt @ Some(_) =>
-        opt
-      case None =>
+  /**
+    * If this player is a member of any squad, discover that squad.
+    * @see `GetParticipatingSquad`
+    * @see `Squad::Leader`
+    * @param player the potential member
+    * @param opt an optional squad to check;
+    *            the expectation is that the provided squad is a known participating squad
+    * @return the discovered squad, or `None`
+    */
+  def GetLeadingSquad(player : Player, opt : Option[Squad]) : Option[Squad] = GetLeadingSquad(player.CharId, opt)
+
+  /**
+    * If the player associated with this unique character identifier number is the leader of any squad, discover that squad.
+    * @see `GetParticipatingSquad`
+    * @see `Squad->Leader`
+    * @param charId the potential member identifier
+    * @param opt an optional squad to check;
+    *            the expectation is that the provided squad is a known participating squad
+    * @return the discovered squad, or `None`
+    */
+  def GetLeadingSquad(charId : Long, opt : Option[Squad]) : Option[Squad] = opt.orElse(GetParticipatingSquad(charId)) match {
+    case Some(squad) =>
+      if(squad.Leader.CharId == charId) {
+        Some(squad)
+      }
+      else {
         None
-    }
+      }
+    case _ =>
+      None
   }
 
-  def GetLeadingSquad(player : Player, opt : Option[Squad]) : Option[Squad] = {
-    val charId = player.CharId
-    opt match {
-      case Some(squad) =>
-        if(squad.Leader.CharId == charId) {
-          Some(squad)
-        }
-        else {
-          None
-        }
-
-      case None =>
-        memberToSquad.get(charId) match {
-          case Some(squad) if squad.Leader.CharId == charId =>
-            Some(squad)
-          case _ =>
-            None
-        }
-    }
+  /**
+    * Overloaded message-sending operation.
+    * The `Actor` version wraps around the expected `!` functionality.
+    * @param to an `ActorRef` which to send the message
+    * @param msg a message that can be stored in a `SquadServiceResponse` object
+    */
+  def Publish(to : ActorRef, msg : SquadResponse.Response) : Unit = {
+    Publish(to, msg, Nil)
   }
-
-  def GetLeadingSquad(charId : Long, opt : Option[Squad]) : Option[Squad] = {
-    opt.orElse(memberToSquad.get(charId)) match {
-      case Some(squad) =>
-        if(squad.Leader.CharId == charId) {
-          Some(squad)
-        }
-        else {
-          None
-        }
+  /**
+    * Overloaded message-sending operation.
+    * The `Actor` version wraps around the expected `!` functionality.
+    * @param to an `ActorRef` which to send the message
+    * @param msg a message that can be stored in a `SquadServiceResponse` object
+    * @param excluded a group of character identifier numbers who should not receive the message
+    *                 (resolved at destination)
+    */
+  def Publish(to : ActorRef, msg : SquadResponse.Response, excluded : Iterable[Long]) : Unit = {
+    to ! SquadServiceResponse("", excluded, msg)
+  }
+  /**
+    * Overloaded message-sending operation.
+    * Always publishes on the `SquadEvents` object.
+    * @param to a faction affiliation used as the channel for the message
+    * @param msg a message that can be stored in a `SquadServiceResponse` object
+    */
+  def Publish(to : PlanetSideEmpire.Type, msg : SquadResponse.Response) : Unit = {
+    Publish(to, msg, Nil)
+  }
+  /**
+    * Overloaded message-sending operation.
+    * Always publishes on the `SquadEvents` object.
+    * @param to a faction affiliation used as the channel for the message
+    * @param msg a message that can be stored in a `SquadServiceResponse` object
+    * @param excluded a group of character identifier numbers who should not receive the message
+    *                 (resolved at destination)
+    */
+  def Publish(to : PlanetSideEmpire.Type, msg : SquadResponse.Response, excluded : Iterable[Long]) : Unit = {
+    SquadEvents.publish(SquadServiceResponse(s"/$to/Squad", excluded, msg))
+  }
+  /**
+    * Overloaded message-sending operation.
+    * Strings come in three accepted patterns.
+    * The first resolves into a faction name, as determined by `PlanetSideEmpire` when transformed into a string.
+    * The second resolves into a squad's dedicated channel, a name that is formulaic.
+    * The third resolves as a unique character identifier number.
+    * @param to a string used as the channel for the message
+    * @param msg a message that can be stored in a `SquadServiceResponse` object
+    */
+  def Publish(to : String, msg : SquadResponse.Response) : Unit = {
+    Publish(to, msg, Nil)
+  }
+  /**
+    * Overloaded message-sending operation.
+    * Strings come in three accepted patterns.
+    * The first resolves into a faction name, as determined by `PlanetSideEmpire` when transformed into a string.
+    * The second resolves into a squad's dedicated channel, a name that is formulaic.
+    * The third resolves as a unique character identifier number.
+    * @param to a string used as the channel for the message
+    * @param msg a message that can be stored in a `SquadServiceResponse` object
+    * @param excluded a group of character identifier numbers who should not receive the message
+    *                 (resolved at destination, usually)
+    */
+  def Publish(to : String, msg : SquadResponse.Response, excluded : Iterable[Long]) : Unit = {
+    to match {
+      case str if "TRNCVS".indexOf(str) > -1 || str.matches("(TR|NC|VS)-Squad\\d+") =>
+        SquadEvents.publish(SquadServiceResponse(s"/$str/Squad", excluded, msg))
+      case str if str.matches("//d+") =>
+        Publish(to.toLong, msg, excluded)
       case _ =>
-        None
+        log.error(s"Publish(String): subscriber information is an unhandled format - $to")
     }
   }
-
-  def CreateSquad(player : Player) : Squad = {
-    val faction = player.Faction
-    val name = player.Name
-    val squad = new Squad(GetNextSquadId(), faction)
-    val leadPosition = squad.Membership(squad.LeaderPositionIndex)
-    leadPosition.Name = name
-    leadPosition.CharId = player.CharId
-    leadPosition.Health = player.Health
-    leadPosition.Armor = player.Armor
-    leadPosition.Position = player.Position
-    leadPosition.ZoneId = 1
-    log.info(s"$name-$faction has created a new squad")
-    squad
+  /**
+    * Overloaded message-sending operation.
+    * Always publishes on the `ActorRef` objects retained by the `UserEvents` object.
+    * @param to a unique character identifier used as the channel for the message
+    * @param msg a message that can be stored in a `SquadServiceResponse` object
+    */
+  def Publish(to : Long, msg : SquadResponse.Response) : Unit = {
+    UserEvents.get(to) match {
+      case Some(user) =>
+        user ! SquadServiceResponse("", msg)
+      case None =>
+        log.error(s"Publish(Long): subscriber information can not be found - $to")
+    }
   }
-
-  def StartSquad(squad : Squad) : Squad = {
-    squadFeatures += squad.GUID -> new SquadService.SquadFeatures(squad).Start
-    memberToSquad += squad.Leader.CharId -> squad
-    squad
+  /**
+    * Overloaded message-sending operation.
+    * Always publishes on the `ActorRef` objects retained by the `UserEvents` object.
+    * @param to a unique character identifier used as the channel for the message
+    * @param msg a message that can be stored in a `SquadServiceResponse` object
+    * @param excluded a group of character identifier numbers who should not receive the message
+    */
+  def Publish(to : Long, msg : SquadResponse.Response, excluded : Iterable[Long]) : Unit = {
+    if(!excluded.exists(_ == to)) {
+      Publish(to, msg)
+    }
   }
-
-  def StartSquad(player : Player) : Squad = {
-    val squad = CreateSquad(player)
-    StartSquad(squad)
-    squad
+  /**
+    * Overloaded message-sending operation.
+    * No message can be sent using this distinction.
+    * Log a warning.
+    * @param to something that was expected to be used as the channel for the message
+    *           but is not handled as such
+    * @param msg a message that can be stored in a `SquadServiceResponse` object
+    */
+  def Publish[ANY >: Any](to : ANY, msg : SquadResponse.Response) : Unit = {
+    log.warn(s"Publish(Any): subscriber information is an unhandled format - $to")
+  }
+  /**
+    * Overloaded message-sending operation.
+    * No message can be sent using this distinction.
+    * Log a warning.
+    * @param to something that was expected to be used as the channel for the message
+    *           but is not handled as such
+    * @param msg a message that can be stored in a `SquadServiceResponse` object
+    * @param excluded a group of character identifier numbers who should not receive the message
+    */
+  def Publish[ANY >: Any](to : ANY, msg : SquadResponse.Response, excluded : Iterable[Long]) : Unit = {
+    log.warn(s"Publish(Any): subscriber information is an unhandled format - $to")
   }
-
-  val SquadEvents = new GenericEventBus[SquadServiceResponse]
 
   def receive : Receive = {
     //subscribe to a faction's channel - necessary to receive updates about listed squads
     case Service.Join(faction) if "TRNCVS".indexOf(faction) > -1 =>
       val path = s"/$faction/Squad"
       val who = sender()
-      log.info(s"$who has joined $path")
+      debug(s"$who has joined $path")
       SquadEvents.subscribe(who, path)
-      //send initial squad catalog
-      sender ! SquadServiceResponse(s"/$faction/Squad", SquadResponse.InitList(publishedLists(PlanetSideEmpire(faction)).toVector))
 
     //subscribe to the player's personal channel - necessary for future and previous squad information
     case Service.Join(char_id) =>
-      val path = s"/$char_id/Squad"
-      val who = sender()
-      log.info(s"$who has joined $path")
-      SquadEvents.subscribe(who, path)
-      //check for renewable squad information
-      val longCharId = char_id.toLong
-      memberToSquad.get(longCharId) match {
-        case None => ;
-        case Some(squad) =>
-          val guid = squad.GUID
-          val indices = squad.Membership.zipWithIndex.collect({ case (member, index) if member.CharId != 0 => index }).toList
-          SquadEvents.publish(SquadServiceResponse(s"/$char_id/Squad", SquadResponse.AssociateWithSquad(guid)))
-          SquadEvents.publish(SquadServiceResponse(s"/$char_id/Squad", SquadResponse.Join(squad, indices)))
-          InitSquadDetail(guid, Seq(longCharId), squad)
-          InitWaypoints(longCharId, guid)
+      try {
+        val longCharId = char_id.toLong
+        val path = s"/$char_id/Squad"
+        val who = sender()
+        debug(s"$who has joined $path")
+        context.watch(who)
+        UserEvents += longCharId -> who
+        refused(longCharId) = Nil
+      }
+      catch {
+        case _ : ClassCastException =>
+          log.warn(s"Service.Join: tried $char_id as a unique character identifier, but it could not be casted")
+        case e : Exception =>
+          log.error(s"Service.Join: unexpected exception using $char_id as data - ${e.getLocalizedMessage}")
+          e.printStackTrace()
       }
 
-    case Service.Leave(Some(char_id)) =>
-      SquadEvents.unsubscribe(sender())
-      val longCharId = char_id.toLong
-      val pSquadOpt = GetParticipatingSquad(longCharId)
-      (pSquadOpt, GetLeadingSquad(longCharId, pSquadOpt)) match {
-        case (Some(_), Some(squad)) =>
-          //leader of a squad; the squad will be disbanded
-          DisbandSquad(squad)
-        case (Some(squad), None) if squad.Size == 2 =>
-          //one of the last two members of a squad; the squad will be disbanded
-          DisbandSquad(squad)
-        case (Some(squad), None) =>
-          //member of the squad; leave the squad
-          LeaveSquad(longCharId, squad)
-        case _ =>
-          //not a member of any squad; nothing to do here
-      }
-      CleanupInvitesFromPlayer(longCharId)
+    case Service.Leave(Some(char_id)) => LeaveService(char_id, sender)
 
-    case Service.Leave(None) | Service.LeaveAll() => ;
+    case Service.Leave(None) | Service.LeaveAll() => UserEvents find { case(_, subscription) => subscription == sender} match {
+      case Some((to, _)) =>
+        LeaveService(to, sender)
+      case _ => ;
+    }
+
+    case Terminated(actorRef) =>
+      context.unwatch(actorRef)
+      UserEvents find { case(_, subscription) => subscription eq actorRef} match {
+        case Some((to, _)) =>
+          LeaveService(to, sender)
+        case _ => ;
+      }
 
     case SquadServiceMessage(tplayer, zone, squad_action) => squad_action match {
-      case SquadAction.Membership(SquadRequestType.Invite, invitingPlayer, Some(invitedPlayer), _, _) =>
+      case SquadAction.InitSquadList() =>
+        Publish( sender, SquadResponse.InitList(PublishedLists(tplayer.Faction)) ) //send initial squad catalog
+
+      case SquadAction.InitCharId() =>
+        val charId = tplayer.CharId
+        memberToSquad.get(charId) match {
+          case None => ;
+          case Some(squad) =>
+            val guid = squad.GUID
+            val toChannel = s"/${squadFeatures(guid).ToChannel}/Squad"
+            val indices = squad.Membership.zipWithIndex.collect({ case (member, index) if member.CharId != 0 => index }).toList
+            Publish(charId, SquadResponse.AssociateWithSquad(guid))
+            Publish(charId, SquadResponse.Join(squad, indices, toChannel))
+            InitSquadDetail(guid, Seq(charId), squad)
+            InitWaypoints(charId, guid)
+        }
+
+      case SquadAction.Membership(SquadRequestType.Invite, invitingPlayer, Some(_invitedPlayer), invitedName, _) =>
         //this is just busy work; for actual joining operations, see SquadRequestType.Accept
-        (memberToSquad.get(invitingPlayer), memberToSquad.get(invitedPlayer)) match {
-          case (Some(squad1), Some(squad2))
-            if squad1.GUID == squad2.GUID =>
-            //both players are in the same squad; no need to do anything
+        (if(invitedName.nonEmpty) {
+          //validate player with name exists
+          LivePlayerList.WorldPopulation({ case (_, a : Avatar) => a.name == invitedName }).headOption match {
+            case Some(player) => UserEvents.keys.find(_ == player.CharId)
+            case None => None
+          }
+        }
+        else {
+          //validate player with id exists
+          UserEvents.keys.find(_ == _invitedPlayer)
+        }) match {
+          case Some(invitedPlayer) =>
+            (memberToSquad.get(invitingPlayer), memberToSquad.get(invitedPlayer)) match {
+              case (Some(squad1), Some(squad2)) if squad1.GUID == squad2.GUID =>
+              //both players are in the same squad; no need to do anything
 
-          case (Some(squad1), Some(squad2))
-            if squad1.Leader.CharId == invitingPlayer && squad2.Leader.CharId == invitedPlayer &&
-              squad1.Size > 1 && squad2.Size > 1 =>
-            //we might do some platoon chicanery with this case later
-            //TODO platoons
+              case (Some(squad1), Some(squad2)) if squad1.Leader.CharId == invitingPlayer && squad2.Leader.CharId == invitedPlayer &&
+                squad1.Size > 1 && squad2.Size > 1 =>
+              //we might do some platoon chicanery with this case later
+              //TODO platoons
 
-          case (Some(squad1), Some(squad2))
-            if squad2.Size == 1 && !squadFeatures(squad1.GUID).Refuse.contains(invitedPlayer) =>
-            //both players belong to squads, but the invitedplayer's squad (squad2) is underutilized by comparison
-            //treat the same as "the classic situation" using squad1
-            log.info(s"$invitedPlayer has been invited to squad ${squad1.Task} by $invitingPlayer")
-            val charId = tplayer.CharId
-            AddInviteAndRespond(
-              invitedPlayer,
-              VacancyInvite(charId, tplayer.Name, squad1.GUID),
-              charId,
-              tplayer.Name
-            )
+              case (Some(squad1), Some(squad2)) if squad2.Size == 1 =>
+                //both players belong to squads, but the invitedPlayer's squad (squad2) is underutilized by comparison
+                //treat the same as "the classic situation" using squad1
+                if(!Refused(invitedPlayer).contains(invitingPlayer)) {
+                  val charId = tplayer.CharId
+                  AddInviteAndRespond(
+                    invitedPlayer,
+                    VacancyInvite(charId, tplayer.Name, squad1.GUID),
+                    charId,
+                    tplayer.Name
+                  )
+                }
 
-          case (Some(squad1), Some(squad2))
-            if squad1.Size == 1 && !squadFeatures(squad2.GUID).Refuse.contains(invitingPlayer) =>
-            //both players belong to squads, but the invitingPlayer's squad is underutilized by comparison
-            //treat the same as "indirection ..." using squad2
-            log.warn(s"$invitedPlayer has asked $invitingPlayer for an invitation to squad ${squad2.Task}, but the squad leader may need to approve")
-            AddInviteAndRespond(
-              squad2.Leader.CharId,
-              IndirectInvite(tplayer, squad2.GUID),
-              invitingPlayer,
-              tplayer.Name
-            )
+              case (Some(squad1), Some(squad2)) if squad1.Size == 1 =>
+                //both players belong to squads, but the invitingPlayer's squad is underutilized by comparison
+                //treat the same as "indirection ..." using squad2
+                val leader = squad2.Leader.CharId
+                if(Refused(invitingPlayer).contains(invitedPlayer)) {
+                  debug(s"$invitedPlayer repeated a previous refusal to $invitingPlayer's invitation offer")
+                }
+                else if(Refused(invitingPlayer).contains(leader)) {
+                  debug(s"$invitedPlayer repeated a previous refusal to $leader's invitation offer")
+                }
+                else {
+                  AddInviteAndRespond(
+                    leader,
+                    IndirectInvite(tplayer, squad2.GUID),
+                    invitingPlayer,
+                    tplayer.Name
+                  )
+                }
 
-          case (Some(squad), None)
-            if !squadFeatures(squad.GUID).Refuse.contains(invitedPlayer) =>
-            //the classic situation
-            log.info(s"$invitedPlayer has been invited to squad ${squad.Task} by $invitingPlayer")
-            AddInviteAndRespond(
-              invitedPlayer,
-              VacancyInvite(tplayer.CharId, tplayer.Name, squad.GUID),
-              invitingPlayer,
-              tplayer.Name
-            )
+              case (Some(squad), None) =>
+                //the classic situation
+                if(!Refused(invitedPlayer).contains(invitingPlayer)) {
+                  AddInviteAndRespond(
+                    invitedPlayer,
+                    VacancyInvite(tplayer.CharId, tplayer.Name, squad.GUID),
+                    invitingPlayer,
+                    tplayer.Name
+                  )
+                }
+                else {
+                  debug(s"$invitedPlayer repeated a previous refusal to $invitingPlayer's invitation offer")
+                }
 
-          case (None, Some(squad))
-            if !squadFeatures(squad.GUID).Refuse.contains(invitingPlayer) =>
-            //indirection;  we're trying to invite ourselves to someone else's squad
-            log.warn(s"$invitedPlayer has asked $invitingPlayer for an invitation to squad ${squad.Task}, but the squad leader may need to approve")
-            AddInviteAndRespond(
-              squad.Leader.CharId,
-              IndirectInvite(tplayer, squad.GUID),
-              invitingPlayer,
-              tplayer.Name
-            )
+              case (None, Some(squad)) =>
+                //indirection;  we're trying to invite ourselves to someone else's squad
+                val leader = squad.Leader.CharId
+                if(Refused(invitingPlayer).contains(invitedPlayer)) {
+                  debug(s"$invitedPlayer repeated a previous refusal to $invitingPlayer's invitation offer")
+                }
+                else if(Refused(invitingPlayer).contains(leader)) {
+                  debug(s"$invitedPlayer repeated a previous refusal to $leader's invitation offer")
+                }
+                else {
+                  AddInviteAndRespond(
+                    squad.Leader.CharId,
+                    IndirectInvite(tplayer, squad.GUID),
+                    invitingPlayer,
+                    tplayer.Name
+                  )
+                }
 
-          case (None, None) =>
-            //neither the invited player nor the inviting player belong to any squad
-            log.info(s"$invitedPlayer has been invited to join $invitingPlayer's spontaneous squad")
-            AddInviteAndRespond(
-              invitedPlayer,
-              SpontaneousInvite(tplayer),
-              invitingPlayer,
-              tplayer.Name
-            )
+              case (None, None) =>
+                //neither the invited player nor the inviting player belong to any squad
+                if(Refused(invitingPlayer).contains(invitedPlayer)) {
+                  debug(s"$invitedPlayer repeated a previous refusal to $invitingPlayer's invitation offer")
+                }
+                else if(Refused(invitedPlayer).contains(invitingPlayer)) {
+                  debug(s"$invitingPlayer repeated a previous refusal to $invitingPlayer's invitation offer")
+                }
+                else {
+                  AddInviteAndRespond(
+                    invitedPlayer,
+                    SpontaneousInvite(tplayer),
+                    invitingPlayer,
+                    tplayer.Name
+                  )
+                }
 
-          case _ => ;
+              case _ => ;
+            }
+          case None => ;
         }
 
       case SquadAction.Membership(SquadRequestType.ProximityInvite, invitingPlayer, _, _, _) =>
-        memberToSquad.get(invitingPlayer) match {
+        GetLeadingSquad(invitingPlayer, None) match {
           case Some(squad) =>
             val sguid = squad.GUID
             val features = squadFeatures(sguid)
             features.SearchForRole match {
               case Some(-1) =>
                 //we've already issued a proximity invitation; no need to do another
-                log.info("ProximityInvite: waiting for existing proximity invitations to clear")
+                debug("ProximityInvite: wait for existing proximity invitations to clear")
               case _ =>
-                log.info("ProximityInvite: looking for invitation targets ...")
                 val outstandingActiveInvites = features.SearchForRole match {
                   case Some(pos) =>
                     RemoveQueuedInvitesForSquadAndPosition(sguid, pos)
-                    invites.collect { case(charId, InviteForRole(_,_, squad_guid, role)) if squad_guid == sguid && role == pos => charId }
+                    invites.collect { case(charId, LookingForSquadRoleInvite(_,_, squad_guid, role)) if squad_guid == sguid && role == pos => charId }
                   case None =>
                     List.empty[Long]
                 }
-                features.SearchForRole = Some(-1)
                 val faction = squad.Faction
                 val center = tplayer.Position
                 val excusedInvites = features.Refuse
@@ -312,13 +547,14 @@ class SquadService extends Actor {
                 - have Looking For Squad enabled
                 - do not currently belong to a squad
                 - are denied the opportunity to be invited
-                - are a certain distance from the squad leader
+                - are a certain distance from the squad leader (n < 25m)
                  */
                 (zone.LivePlayers
                   .collect { case player
-                    if player.Faction == faction && player.LFS && memberToSquad.get(player.CharId).isEmpty &&
-                      !excusedInvites.contains(player.CharId) &&
-                      Vector3.DistanceSquared(player.Position, center) < 100f &&
+                    if player.Faction == faction && player.LFS &&
+                      (memberToSquad.get(player.CharId).isEmpty || memberToSquad(player.CharId).Size == 1) &&
+                      !excusedInvites.contains(player.CharId) && Refused(player.CharId).contains(squad.Leader.CharId) &&
+                      Vector3.DistanceSquared(player.Position, center) < 625f &&
                       {
                         positions
                           .map { role =>
@@ -331,15 +567,14 @@ class SquadService extends Actor {
                   .partition { charId => outstandingActiveInvites.exists(_ == charId) } match {
                   case (Nil, Nil) =>
                     //no one found
-                    log.info("ProximityInvite: no invitation targets found")
                     outstandingActiveInvites foreach RemoveInvite
                     features.ProxyInvites = Nil
                     None
                   case (outstandingPlayerList, invitedPlayerList) =>
                     //players who were actively invited for the previous position and are eligible for the new position
-                    log.info(s"ProximityInvite: found ${outstandingPlayerList.size} players already having been invited, and ${invitedPlayerList.size} players to invite")
+                    features.SearchForRole = Some(-1)
                     outstandingPlayerList.foreach { charId =>
-                      val bid = invites(charId).asInstanceOf[InviteForRole]
+                      val bid = invites(charId).asInstanceOf[LookingForSquadRoleInvite]
                       invites(charId) = ProximityInvite(bid.char_id, bid.name, sguid)
                     }
                     //players who were actively invited for the previous position but are ineligible for the new position
@@ -368,40 +603,40 @@ class SquadService extends Actor {
 
       case SquadAction.Membership(SquadRequestType.Accept, invitedPlayer, _, _, _) =>
         val acceptedInvite = RemoveInvite(invitedPlayer)
-        val msg = "Accept: the invited player is already a member of a squad and can not join a second one"
         acceptedInvite match {
-          case Some(BidForRole(petitioner, guid, position)) if EnsureEmptySquad(petitioner.CharId, msg) && squadFeatures.get(guid).nonEmpty =>
+          case Some(RequestRole(petitioner, guid, position)) if EnsureEmptySquad(petitioner.CharId) && squadFeatures.get(guid).nonEmpty =>
             //player requested to join a squad's specific position
             //invitedPlayer is actually the squad leader; petitioner is the actual "invitedPlayer"
             val features = squadFeatures(guid)
+            features.Prompt.cancel
             JoinSquad(petitioner, features.Squad, position)
             RemoveInvitesForSquadAndPosition(guid, position)
 
-          case Some(IndirectInvite(recruit, guid)) if EnsureEmptySquad(recruit.CharId, msg) =>
+          case Some(IndirectInvite(recruit, guid)) if EnsureEmptySquad(recruit.CharId) =>
             //tplayer / invitedPlayer is actually the squad leader
             val recruitCharId = recruit.CharId
             HandleVacancyInvite(guid, recruitCharId, invitedPlayer, recruit) match {
               case Some((squad, line)) =>
-                SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitedPlayer, Some(recruitCharId), recruit.Name, true, Some(None))))
+                Publish(invitedPlayer, SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitedPlayer, Some(recruitCharId), recruit.Name, true, Some(None)))
                 JoinSquad(recruit, squad, line)
                 RemoveInvitesForSquadAndPosition(squad.GUID, line)
               //since we are the squad leader, we do not want to brush off our queued squad invite tasks
               case _ => ;
             }
 
-          case Some(VacancyInvite(invitingPlayer, _, guid)) if EnsureEmptySquad(invitedPlayer, msg) =>
+          case Some(VacancyInvite(invitingPlayer, _, guid)) if EnsureEmptySquad(invitedPlayer) =>
             //accepted an invitation to join an existing squad
             HandleVacancyInvite(guid, invitedPlayer, invitingPlayer, tplayer) match {
               case Some((squad, line)) =>
-                SquadEvents.publish(SquadServiceResponse(s"/$invitingPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitingPlayer, Some(invitedPlayer), tplayer.Name, false, Some(None))))
-                SquadEvents.publish(SquadServiceResponse(s"/$invitedPlayer/Squad", SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitedPlayer, Some(invitingPlayer), "", true, Some(None))))
+                Publish(invitingPlayer, SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitingPlayer, Some(invitedPlayer), tplayer.Name, false, Some(None)))
+                Publish(invitedPlayer, SquadResponse.Membership(SquadResponseType.Accept, 0, 0, invitedPlayer, Some(invitingPlayer), "", true, Some(None)))
                 JoinSquad(tplayer, squad, line)
                 RemoveQueuedInvites(invitedPlayer) //TODO deal with these somehow
                 RemoveInvitesForSquadAndPosition(squad.GUID, line)
               case _ => ;
             }
 
-          case Some(SpontaneousInvite(invitingPlayer)) if EnsureEmptySquad(invitedPlayer, msg) =>
+          case Some(SpontaneousInvite(invitingPlayer)) if EnsureEmptySquad(invitedPlayer) =>
             //originally, we were invited by someone into a new squad they would form
             val invitingPlayerCharId = invitingPlayer.CharId
             (GetParticipatingSquad(invitingPlayer) match {
